/* $Id: hipe_bif0.h,v 1.10 2002/02/08 12:43:15 mikpe Exp $
 * hipe_bif0.h
 *
 * Compiler and linker support.
 */
#ifndef HIPE_BIF0_H
#define HIPE_BIF0_H

extern int hipe_patch_address(Uint *address, Eterm patchtype, Uint value);

extern Uint *hipe_bifs_find_pc_from_mfa(Eterm mfa);

/* shared with ggc.c -- NOT an official API */
extern Eterm *hipe_constants_start;
extern Eterm *hipe_constants_next;

#include "hash.h"
#include <stddef.h>	/* offsetof() */

struct sdesc {
    HashBucket bucket; /* word 0: hash link, word 1: return address (key) */
    unsigned int summary; /* frame size, exn handler presence flag, arity */
    unsigned int livebits[1]; /* size depends on arch & data in summary field */
};

struct sdesc_with_exnra {
    unsigned long exnra;
    struct sdesc sdesc;
};

static __inline__ unsigned int sdesc_fsize(const struct sdesc *sdesc)
{
    return sdesc->summary >> 9;
}

static __inline__ unsigned int sdesc_arity(const struct sdesc *sdesc)
{
    return sdesc->summary & 0xFF;
}

static __inline__ unsigned long sdesc_exnra(const struct sdesc *sdesc)
{
    if( (sdesc->summary & (1<<8)) ) {
	const char *tmp;
	tmp = (const char*)sdesc - offsetof(struct sdesc_with_exnra, sdesc);
	return ((const struct sdesc_with_exnra*)tmp)->exnra;
    }
    return 0;
}

extern void hipe_init_sdesc_table(struct sdesc*);
extern const struct sdesc *hipe_find_sdesc(unsigned long ra);

#endif /* HIPE_BIF0_H */
