%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Copyright (c) 2001 by Erik Johansson.  All Rights Reserved 
%% Time-stamp: <02/02/06 12:23:03 happi>
%% ====================================================================
%%  Filename : 	hipe_sparc_ra.erl
%%  Module   :	hipe_sparc_ra
%%  Purpose  :  
%%  Notes    : 
%%  History  :	* 2001-07-20 Erik Johansson (happi@csd.uu.se): 
%%               Created.
%%  CVS      :
%%              $Author: happi $
%%              $Date: 2002/02/07 07:35:57 $
%%              $Revision: 1.11 $
%% ====================================================================
%%  Exports  :
%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

-module(hipe_sparc_ra).
-export([allocate/3]).
-define(HIPE_INSTRUMENT_COMPILER, true). %% Turn on instrumentation.
-include("../main/hipe.hrl").

allocate(Fun, SparcCfg, Options) ->
  ?opt_start_timer("Regalloc"),
  ?start_ra_instrumentation(Options, 
			    hipe_sparc_size:count_instrs_cfg(SparcCfg),
			    element(2,hipe_sparc_cfg:var_range(SparcCfg))),
  
  Res = {NewCfg,TempMap, NextPos}  = 
    case property_lists:get_value(regalloc,Options) of
      linear_scan ->
	hipe_sparc_ra_lfls:alloc(
	  hipe_sparc_multimove:remove_multimoves(SparcCfg), Options);
      graph_color ->
	hipe_sparc_ra_graph_color:lf_alloc(hipe_sparc_multimove:remove_multimoves(SparcCfg), Options);
      optimistic_ls -> %% This allocator does not realy excist anymore
	%% since the ordinary linear scan is optimistic.
	hipe_sparc_ra_lfls:alloc(SparcCfg, Options);
      coalescing ->
	hipe_sparc_ra_coalescing:lf_alloc( 
	  hipe_sparc_multimove:remove_multimoves(SparcCfg), Options);
      naive ->
	hipe_sparc_ra_memory:alloc(
	  hipe_sparc_multimove:remove_multimoves(SparcCfg), Options);
      
      _ -> %% linear_scan made default register allocator
	hipe_sparc_ra_lfls:alloc(
	  hipe_sparc_multimove:remove_multimoves(SparcCfg), Options)
    end,
  
	  

  ?opt_stop_timer("Regalloc done"),
  ?stop_ra_instrumentation(Options, 
			    hipe_sparc_size:count_instrs_cfg(NewCfg),
			    element(2,hipe_sparc_cfg:var_range(NewCfg))),

  Res.
