%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Copyright (c) 2001 by Erik Johansson.  All Rights Reserved 
%% -*- erlang-indent-level: 2 -*-
%% ====================================================================
%%  Filename : 	hipe_sparc_stack_descriptors.hrl
%%  Module   :	hipe_sparc_stack_descriptors
%%  Purpose  :  
%%  Notes    : 
%%  History  :	* 2001-11-29 Erik Johansson (happi@csd.uu.se): 
%%               Created.
%%  CVS      :
%%              $Author: happi $
%%              $Date: 2001/11/29 23:10:32 $
%%              $Revision: 1.1 $
%% ====================================================================
%%  Exports  :
%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

-record(stack_desc,{size=0,live_slots=[],dead_slots=[],exn=[], arity=0}).

empty() ->
  #stack_desc{}.

set_live(SD, Live) ->
  NewSD = 
    SD#stack_desc{dead_slots=
		  case  SD#stack_desc.size of 
		    0 -> [];
		    FSize -> [X || X <- lists:seq(1,FSize), not lists:member(X,Live)]
		  end},
  NewSD#stack_desc{live_slots=Live}.
get_live(SD)->
  SD#stack_desc.live_slots.

set_dead(SD, Dead) ->
  NewSD = 
    SD#stack_desc{live_slots=
		  case  SD#stack_desc.size of 
		    0 -> [];
		    FSize -> [X || X <- lists:seq(1,FSize), not lists:member(X,Dead)]
		  end},
  NewSD#stack_desc{dead_slots=Dead}.
get_dead(SD)->
  SD#stack_desc.dead_slots.


set_size(SD, FSize) ->
  Live = SD#stack_desc.live_slots,
  NewSD = 
    SD#stack_desc{dead_slots=
		  case  SD#stack_desc.size of 
		    0 -> [];
		    _ -> [X || X <- lists:seq(1,FSize), not lists:member(X,Live)]
		  end},
  NewSD#stack_desc{size=FSize}.
get_size(SD)->
  SD#stack_desc.size.

set_exn(SD, Exn) ->
  SD#stack_desc{exn=Exn}.
get_exn(SD)->
  SD#stack_desc.exn.

set_arity(SD, Exn) ->
  SD#stack_desc{arity=Exn}.
get_arity(SD)->
  SD#stack_desc.arity.

pp(Dev,SD) ->
  io:format(Dev, "<|~w| Live: ~w>", [get_size(SD),get_live(SD)]).
