%% ``The contents of this file are subject to the Erlang Public License,
%% Version 1.1, (the "License"); you may not use this file except in
%% compliance with the License. You should have received a copy of the
%% Erlang Public License along with this software. If not, it can be
%% retrieved via the world wide web at http://www.erlang.org/.
%% 
%% Software distributed under the License is distributed on an "AS IS"
%% basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
%% the License for the specific language governing rights and limitations
%% under the License.
%% 
%% The Initial Developer of the Original Code is Ericsson Utvecklings AB.
%% Portions created by Ericsson are Copyright 1999, Ericsson Utvecklings
%% AB. All Rights Reserved.''
%% 
%%     $Id$
%%
%%%----------------------------------------------------------------------
%%% Purpose   : Main administative process for listeners and connections
%%%----------------------------------------------------------------------

-module(rshell_server).

-behaviour(gen_server).

-export([start_server/0]).

%% Behaviour interface
-export([init/1,
	 handle_info/2,  
	 code_change/3,
	 handle_cast/2,
	 terminate/2]).

%%---------------------------------------------------------------------------
%% This process does nothing at the moment.
%%---------------------------------------------------------------------------

%%    
%% Spawn the server. This is the call made by the supervisor to start
%% this gen_server
%%
start_server() ->
    gen_server:start_link({local,rshell_server}, ?MODULE, [], []).

init([]) ->
    process_flag(trap_exit,true),
    State = nostate,
    {ok, State}.

%%
%% Terminate server
%%
handle_cast(shutdown, State) ->
    {stop, normal, State}.


%handle_info({'EXIT',From,Reason}, State) ->
    % A process we seem to be linked to has terminated,
    % check if it is in our list of registered Jpid's
    % and remove if it is there.
%    {noreply, state_unregister(From, State)};

handle_info(_What, State) ->
    {noreply, State}.

terminate(_Reason, _State) ->			% normal, shurdown, Any
    % XXX: Cleanup here?
    ok.

code_change(_OldVsn, State, _Extra) ->
    {ok, State}.
